#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#pragma hdrstop
#include <svrapi.h>
#include "nt95delayload.h"



void __stdcall FillSessionList95( const char *server, const char *client, const char *user, SessionList& sl )
{
	char *buf;
	int bufsize, level, successLevel;
	session_info_10 *cur10;
	session_info_50 *cur50;
	DWORD rc, i;
	WORD read, total;

	// client/user filtering is not implemented in 95
	(void) client;
	(void) user;

	buf = NULL;
	successLevel = 90;

	// try levels 10 and 50 in this order, until we don't get a level error
	for ( rc = ERROR_INVALID_LEVEL, level = 10;
		rc == ERROR_INVALID_LEVEL && level <= 50; level += 40 )
	{
		bufsize = 1024;
		do
		{
			printf( "Trying: level %d, bufsize = %d bytes\n", level, bufsize );
			free( buf );
			buf = (char *) malloc( bufsize );

			// NOTE: pre-Jul98 Platform SDKs had bugs in the headers
			// and required a cast for the first three args (to char*).

			rc = NetSessionEnum( server, level, buf, bufsize, &read, &total );

			// printf( "rc = %ld; server = %s, level = %d, buf = %p, bufsize = %d, read = %d, total = %d\n",
			//	(int) rc, server, level, buf, bufsize, (int) read, (int) total );

			if ( rc == 0 )
				successLevel = level;

			bufsize += 1024;
		} while ( bufsize < 65536 && ( rc == ERROR_MORE_DATA || rc == ERROR_INVALID_PARAMETER ) );
	}

	if ( rc != ERROR_SUCCESS )
	{
		printf( "NSE() returned %lu\n", rc );
		exit( 1 );
	}

	// belts and braces
	if ( successLevel != 10 && successLevel != 50 )
	{
		printf( "why is successLevel == %d?\n", successLevel );
		exit( 1 );
	}

	if ( (DWORD) ( sl.nReserved - sl.nUsed ) < read )
	{
		// make some room in the list
		sl.s = (Session *) realloc( sl.s, ( sl.nReserved + max( CHUNK, read ) ) * sizeof sl.s[0] );
		if ( sl.s == NULL )
		{
			printf( "Unable to get memory for %d additional sessions.\n", max( CHUNK, read ) );
			exit( 1 );
		}
		sl.nReserved += max( CHUNK, read );
	}

	switch ( successLevel )
	{
		case 10:
			for ( i = 0, cur10 = (session_info_10 *) buf; i < read; ++ i, ++ cur10 )
			{
				memset( &sl.s[sl.nUsed], '\0', sizeof sl.s[sl.nUsed] );
				if ( cur10->sesi10_cname != NULL )
					sl.s[sl.nUsed].client = strdup( cur10->sesi10_cname );
				if ( cur10->sesi10_username != NULL )
					sl.s[sl.nUsed].user = strdup( cur10->sesi10_username );
				sl.s[sl.nUsed].time = cur10->sesi10_time;
				++ sl.nUsed;
			}
			break;
		case 50:
			for ( i = 0, cur50 = (session_info_50 *) buf; i < read; ++ i, ++ cur50 )
			{
				memset( &sl.s[sl.nUsed], '\0', sizeof sl.s[sl.nUsed] );
				if ( cur50->sesi50_cname != NULL )
					sl.s[sl.nUsed].client = strdup( cur50->sesi50_cname );
				if ( cur50->sesi50_username != NULL )
					sl.s[sl.nUsed].user = strdup( cur50->sesi50_username );
				sl.s[sl.nUsed].time = cur50->sesi50_time;
				++ sl.nUsed;
			}
			break;
		default:
			printf( "why is successLevel == %d, and why didn't the "
				"earlier \"if\" catch it?\n", successLevel );
			exit( 1 );
			break;
	}

	free( buf );
}
